<template>
  <div>
    <employee-navbar
      :page-title="pageTitle"
      :breadcrumb-menu="breadcrumbMenu"
      :is-secondary-page="isSecondaryPage"
      :page-type="pageType"
      @goTo="goTo"
      @handleFormReset="handleFormReset"
      @submit="onSubmit"
    />
    <b-container fluid class="p-3">
      <employee-form ref="form" :editable="true" />
    </b-container>
  </div>
</template>

<script lang="ts">
import { Vue, Component } from 'nuxt-property-decorator'
import { provide, consume } from 'provide-consume-decorator'
import { getModule } from 'vuex-module-decorators'
import { Dictionary } from 'vue-router/types/router'
import Form from '@/components/Employee/EmployeeForm.vue'
import { CreateEmployee } from '@/types/employee'
import EmployeeStore from '@/store/modules/employee'
import EmployeeNavbar from '@/components/Employee/EmployeeNavbar.vue'

interface Store {
  employee: EmployeeStore
}

@Component({
  components: { 'employee-form': Form, EmployeeNavbar },
  head() {
    return {
      title: 'Create an Employee',
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: 'You can create a new employee'
        }
      ]
    }
  }
})
@provide({
  store(): Store {
    return {
      employee: getModule(EmployeeStore, this.$store)
    }
  }
})
export default class EmployeeCreate extends Vue {
  @consume('store') store!: Store

  private pageTitle = 'Add a New Employee'

  private pageType = 'Create'

  private thirdLevelBreadcrumb = {
    cursor: 'default',
    'text-decoration': 'none',
    color: '#cacaca'
  }

  private breadcrumbMenu = [
    {
      text: 'Employees',
      func: this.handleFormReset
    },
    {
      text: 'View & Manage',
      func: this.handleFormReset
    },
    {
      text: 'Add New',
      style: this.thirdLevelBreadcrumb
    }
  ]

  private isSecondaryPage = true

  goTo(name: string, id?: string) {
    const params = {} as Dictionary<string>
    if (id) {
      params.id = id
    }
    this.$router.push({ name, params })
  }

  handleFormReset() {
    this.goTo('employees')
  }

  onSubmit() {
    const data = (this.$refs.form as Vue & {
      handleSubmit: () => CreateEmployee
    }).handleSubmit()

    this.store.employee.createEmployee(data)
  }
}
</script>
